#include "euobj.h"
#include <time.h>
#include <string.h>
#define BENCH_TIME 15
#define SIZE 100
#define INIT_BATCH 2000
#define ADD_BATCH 1000
#define LOOKUP_BATCH 2000
#define SLICE_BATCH 5
#define CONCAT_BENCH 5
#define CONCAT_SIZE 5000
EuObject *toObj(char *s)
{
	EuObject *r = new EuObject();
	r->setType(SEQUENCE);
	for (int i = 0; i < strlen(s); i++)
	{
		r->addItem((int)s[i]);
	}
	return r;
}
void main()
{
	time_t t1, t0;
	printf("\n\t\tEuphoria Sequence Benchmarks\n");
	EuObject *x = new EuObject();
	EuObject *y = new EuObject();
	EuObject *z = new EuObject();
	x->setType(SEQUENCE);
	y->setType(SEQUENCE);
	z->setType(SEQUENCE);
	printf("\n* Initializing a length-%d sequence ---> ", SIZE);
	unsigned long cycles;
	cycles = 0;
	time(&t0);
	while (1)
	{
		time(&t1);
		if (difftime(t1,t0) > BENCH_TIME)
		{
			break;
		}
		for (int j = 1; j <= INIT_BATCH; j++)
		{
			z->setRepeat(new EuObject(999),SIZE);
		}
		cycles += INIT_BATCH;
	}
	time(&t1);
	printf("%d initalizations per second\n",cycles / difftime(t1,t0));
	printf("\n* Adding two length-%d sequences ---> ", SIZE);
	x->clear();
	y->clear();
	for (int i = 0; i < SIZE; i++)
	{
		x->addItem(rand(999));
		y->addItem(rand(999));
	}
	cycles = 0;
	time(&t0);
	while (1)
	{
		time(&t1);
		if (difftime(t1,t0) > BENCH_TIME)
		{
			break;
		}
		for (int j = 1; j <= ADD_BATCH; j++)
		{
			add(x,y,z);
		}
		cycles += ADD_BATCH;
	}
	time(&t1);
	printf("%5d sequence-adds per second\n", cycles / difftime(t1,t0));
	printf("\n* Appending to a sequence ---> ");
	EuObject *s = new EuObject();
	s->setType(SEQUENCE);
	cycles = 0;
	time(&t0);
	while (1)
	{
		time(&t1);
		if (difftime(t1,t0) > BENCH_TIME)
		{
			break;
		}
		for (int j = 1; j <= CONCAT_BENCH; j++)
		{
			s->clear();
			for (int k = 1; k <= CONCAT_SIZE; k++)
			{
				s->addItem((int)'*');
			}
		}
		cycles += CONCAT_BENCH * CONCAT_SIZE;
	}
	time(&t1);
	printf("%d appends per second\n", cycles / difftime(t1,t0));
	printf("\n* Slicing a sequence ---> ");
	cycles = 0;
	time(&t0);
	EuObject *p = new EuObject();
	p->setType(SEQUENCE);
	time(&t0);
	while (1)
	{
		time(&t1);
		if (difftime(t1,t0) > BENCH_TIME)
		{
			break;
		}
		for (int j = 1; j <= SLICE_BATCH; j++)
		{
			p->setValue(s);
			while (p->getLength() >= 2)
			{
				p->setValue(p->getSubscripts(2,p->getLength()-1));
			}
		}
		cycles += SLICE_BATCH * s->getLength() / 2;
	}
	time(&t0);
	printf("%d slices per second\n", cycles / difftime(t1,t0));
	exit(0);
	/*printf("\n* Name look-up ---> ");
	EuObject *states = new EuObject();
	states->setType(SEQUENCE);
    states->addItem(toObj("Kentucky"));
    states->addItem(toObj("Alabama"));
    states->addItem(toObj("California"));
    states->addItem(toObj("Washington"));
    states->addItem(toObj("Ohio"));
    states->addItem(toObj("Texas"));
    states->addItem(toObj("Nevada"));
    states->addItem(toObj("Florida"));
    states->addItem(toObj("Wyoming"));
    states->addItem(toObj("New York"));
    states->addItem(toObj("Maine"));
    states->addItem(toObj("Massachusetts"));
    states->addItem(toObj("North Carolina"));
    states->addItem(toObj("South Carolina"));
    states->addItem(toObj("North Dakota"));
    states->addItem(toObj("South Dakota"));
    states->addItem(toObj("Mississippi"));
    states->addItem(toObj("Arizona"));
    states->addItem(toObj("Hawaii"));
    states->addItem(toObj("Alaska"));
    states->addItem(toObj("Oregon"));
    states->addItem(toObj("Michigan"));
    states->addItem(toObj("Illinois"));
    states->addItem(toObj("Pennsylvania"));
    states->addItem(toObj("Kansas"));
    states->addItem(toObj("Virginia"));
    states->addItem(toObj("New Mexico"));
    states->addItem(toObj("Rhode Island"));
    states->addItem(toObj("New Hampshire"));
    states->addItem(toObj("Delaware"));
    states->addItem(toObj("Tennessee"));
    states->addItem(toObj("Colorado"));
    states->addItem(toObj("Wisconsin"));
    states->addItem(toObj("Vermont"));
    states->addItem(toObj("Indiana"));
    states->addItem(toObj("Maryland"));
    states->addItem(toObj("Connecticut"));
    states->addItem(toObj("Louisiana"));
    states->addItem(toObj("Missouri"));
    states->addItem(toObj("Minnesota"));
    states->addItem(toObj("Iowa"));
    states->addItem(toObj("Idaho"));
    states->addItem(toObj("Arkansas"));
    states->addItem(toObj("Montana"));
    states->addItem(toObj("Nebraska"));
    states->addItem(toObj("Georgia"));
    states->addItem(toObj("West Virginia"));
    states->addItem(toObj("Utah"));
    states->addItem(toObj("New Jersey"));
    states->addItem(toObj("Oklahoma"));*/
    cycles = 0;
    time(&t0);
    while (1)
    {
		time(&t1);
		if (difftime(t1,t0) > BENCH_TIME)
		{
			break;
		}
		for (i = 1; i <= LOOKUP_BATCH; i++)
		{
			if (0)
			{
			}
		}
    }
}